Bug 809949

Summary: Bugs found in python-meld3-0.6.7-5.fc17 using gcc-with-cpychecker static analyzer
Product: [Fedora] Fedora Reporter: Dave Malcolm <dmalcolm>
Component: python-meld3Assignee: Nils Philippsen <nphilipp>
Status: CLOSED EOL QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 19CC: nphilipp
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
URL: http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-04-04/python-meld3-0.6.7-5.fc17/
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-02-17 09:12:22 EST Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 789472    

Description Dave Malcolm 2012-04-04 13:47:24 EDT
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-meld3-0.6.7-5.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-04-04/python-meld3-0.6.7-5.fc17/

I've manually reviewed the issues reported by the tool.

Within the category "Reference count too low" of the 5 issues reported:
  meld3/cmeld3.c:findmeld:ob_refcnt of return value is 1 too low
    Genuine bug, if 0 children

  meld3/cmeld3.c:getiterator:ob_refcnt of return value is 1 too low
    Not sure if this is a bug or not

  meld3/cmeld3.c:bfclone:ob_refcnt of return value is 1 too low
    Not sure if this is a bug or not

  meld3/cmeld3.c:contenthandler:ob_refcnt of heap-region-6 is 1 too low
    Not sure if this is a bug or not ("emptyattrs")

  meld3/cmeld3.c:contenthandler:ob_refcnt of heap-region-10 is 1 too low
    Not sure if this is a bug or not ("emptychildren")

Within the category "Reference leaks" of the 5 issues reported:
  meld3/cmeld3.c:bfclonehandler:ob_refcnt of '*pchildren' is 1 too high
    Genuine bug, in error-handling clause

  meld3/cmeld3.c:getiterator:ob_refcnt of '*node' is 1 too high
    Not sure

  meld3/cmeld3.c:getiterator:ob_refcnt of '*children' is 1 too high
    Genuine bug, in error-handling clause

  meld3/cmeld3.c:bfclone:ob_refcnt of '*L' is 1 too high
    Genuine bug, in error-handling clause

  meld3/cmeld3.c:getiteratorhandler:ob_refcnt of '*list' is 1 too high
    Not sure: does get_iterator steal the reference?
    
Within the category "Segfaults within error-handling paths" the 1 issue
reported:
  meld3/cmeld3.c:findmeld:calling PyList_Size with NULL as argument 1 (children) at meld3/cmeld3.c:277
    Will segfault if PyObject_GetAttr() fails

Within the category "Possible reference leaks" the 5 issues reported may or may not be genuine bugs (not sure without more context).

Within the category "Returning (PyObject*)NULL without setting an exception" the 3 issues reported may or may not be genuine bugs (not sure without more context).

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-meld3-0.6.7-5.fc17
gcc-python-plugin post-0.9 git 796fa7a73adfddb182c2edad70694b5ebca337b9 running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 12:34:53 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Fedora End Of Life 2015-01-09 12:06:03 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2015-02-17 09:12:22 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.